Codeforces Round #284 (Div. 1) B. Name That Tune(概率DP)(难)

B. Name That Tune
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

It turns out that you are a great fan of rock band AC/PE. Peter learned that and started the following game: he plays the first song of the list of n songs of the group, and you have to find out the name of the song. After you tell the song name, Peter immediately plays the following song in order, and so on.

The i-th song of AC/PE has its recognizability pi. This means that if the song has not yet been recognized by you, you listen to it for exactly one more second and with probability of pi percent you recognize it and tell it's name. Otherwise you continue listening it. Note that you can only try to guess it only when it is integer number of seconds after the moment the song starts playing.

In all AC/PE songs the first words of chorus are the same as the title, so when you've heard the first ti seconds of i-th song and its chorus starts, you immediately guess its name for sure.

For example, in the song Highway To Red the chorus sounds pretty late, but the song has high recognizability. In the song Back In Blue, on the other hand, the words from the title sound close to the beginning of the song, but it's hard to name it before hearing those words. You can name both of these songs during a few more first seconds.

Determine the expected number songs of you will recognize if the game lasts for exactly T seconds (i. e. you can make the last guess on the second T, after that the game stops).

If all songs are recognized faster than in T seconds, the game stops after the last song is recognized.

Input

The first line of the input contains numbers n and T (1 ≤ n ≤ 50001 ≤ T ≤ 5000), separated by a space. Next n lines contain pairs of numbers pi and ti (0 ≤ pi ≤ 1001 ≤ ti ≤ T). The songs are given in the same order as in Petya's list.

Output

Output a single number — the expected number of the number of songs you will recognize in T seconds. Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Sample test(s)
input
2 2
50 2
10 1
output
1.500000000
input
2 2
0 2
100 2
output
1.000000000
input
3 3
50 3
50 2
25 2
output
1.687500000
input
2 2
0 2
0 2
output
1.000000000





大致题意:听歌识曲,有n首歌,每首歌有ti的时间供你猜,当到ti时就会播放歌曲名所以必定会猜中,除了ti秒以外,其它每s猜中的概率是p,求Ts后猜中的歌曲个数的期望


我们设dp[i][j]表示猜到第i首歌,所用时间恰好为j的概率。

如果第i首歌识别的概率是pi。最多所用次数为ti。

如今我们识别第i首歌所用总时间恰好为j,那么其可能是dp[i-1][j-ti],dp[i-1][j-ti+1],......,dp[i-1][j-1]转移过来的。

显然暴力dp的复杂度是O(n^3)会T,所以进一步优化,dp[i][j]可由dp[i][j-1] O(1)推得

期望等于每首歌被猜中的概率之和

#include<cstdio>
#include<iostream>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;


const int N =5e3+100;
int n,T;
double dp[N][N];
double p[N];
int t[N];

int main()
{
    cin>>n>>T;
    for(int  i=1;i<=n;i++) cin>>p[i],p[i]=p[i]/100,cin>>t[i];
    dp[0][0]=1;
    double ans=0;
    for(int i=0;i<=n;i++)
    {
        double pp1,pp2;
        if(i>0&&t[i]>2) pp1=pow(1-p[i],1.0*(t[i]-2));
        pp2=pow(1-p[i+1],t[i+1]-1);
        for(int j=0;j<=T;j++)
        {
            if(dp[i][j]==0) continue;
            if(i>0&&t[i]>2)
            {
                double tmp=dp[i][j];
                if(j>=t[i]) tmp-=dp[i-1][j-t[i]]*pp1*(1-p[i]);
                if(j>=t[i]-1) tmp-=dp[i-1][j-t[i]+1]*pp1*p[i];
                dp[i][j+1]+=tmp*(1-p[i]);
            }
            if(j+1<=T&&t[i+1]>1) dp[i+1][j+1]+=dp[i][j]*p[i+1];
            if(j+t[i+1]<=T)dp[i+1][j+t[i+1]]+=dp[i][j]*pp2;
            if(i>0) ans+=dp[i][j];
        }
    }
    printf("%.10f\n",ans);
}



转载于:https://www.cnblogs.com/yxysuanfa/p/7086330.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值